#ifndef _MAPOBJECT_H
#define _MAPOBJECT_H

#include <vector>
#include "robotworld.h"
class Map;


class MapObject
{
public:
	MapObject(Map&);
	virtual ~MapObject();

	void SetPos(double,double);
	double GetX() { return m_x; }
	double GetY() { return m_y; }
	void SetDeleteByMap(bool x = true) { m_delete_by_map = x; }
	bool DeleteByMap() { return m_delete_by_map; }

	virtual long get_property(const std::string& ) = 0;

	// common properties
	virtual mapobject_t GetType() = 0;

private:
	Map& m_map;
	double m_x;
	double m_y;
	bool m_delete_by_map;
};
typedef std::vector<MapObject *> mapobject_v;



#endif // _MAPOBJECT_H
