#ifndef _ROBOTOBJECT_H
#define _ROBOTOBJECT_H

#include <vector>
#include "CodeTool.h"

class Robot;


class RobotObject
{
public:
	RobotObject(Robot& );
	virtual ~RobotObject();

	virtual void Tick(long usec);

	virtual long get_property(int) = 0;
	virtual void set_property(int,long) = 0;
	virtual long call_method(int,stack_v&) = 0;

	int GetMaxLife() { return m_max_life; }
	void SetMaxLife(int x) { m_max_life = x; }
	int GetLife() { return (int)m_life; }
	void SetLife(int x) { m_life = (double)x; }
	int GetDamage() { return (int)((m_life * 100) / m_max_life); }
	bool Ok() { return GetDamage() > 0; }
	void SetRepairRate(int x) { m_repair_rate = x; }
	int GetRepairRate() { return m_repair_rate; }

	Robot& GetRobot() { return m_robot; }

private:
	Robot& m_robot;
	int m_max_life;
	double m_life;
	int m_repair_rate; // % of max power/sec - 100 power units repair 1 life
};



#endif // _ROBOTOBJECT_H
