//#include <stdio.h>

#include <Parse.h>
#include <Base64.h>
#include "RobotXMLFile.h"




RobotXMLFile::RobotXMLFile(const std::string& filename)
:BaseXMLFile(filename, "", "robot")
{
}


RobotXMLFile::~RobotXMLFile()
{
}


xmlNodePtr RobotXMLFile::Find(xmlNodePtr base,const std::string& path)
{
	Parse pa(path,"/");
	std::string ord = pa.getword();
	std::string str = pa.getrest();
	xmlNodePtr p = GetFirstElement(base,ord);
	if (p && str.size())
	{
		return Find(p,str);
	}
	return p;
}


std::string RobotXMLFile::GetString(const std::string& path,const std::string& property)
{
	xmlNodePtr p = Find(GetRootElement(),path);
	if (p)
	{
		SetCurrent(p);
		std::string str = GetProperty(property);
		return str;
	}
	fprintf(stderr,"config path not found: %s\n",path.c_str());
	return "";
}


void RobotXMLFile::GetMethods(std::map<std::string,int>& mmap)
{
	xmlNodePtr p = GetFirstElement("methods");
	if (p)
	{
		SetCurrent(p);
		p = GetChildrenNode();
		while (p)
		{
			std::string name = GetProperty("name");
			std::string entry = GetProperty("entry");
			if (name.size())
				mmap[name] = atoi(entry.c_str());
			//
			p = GetNextNode();
		}
	}
}


void RobotXMLFile::GetVariables(std::vector<VARIABLE *>& ref)
{
	xmlNodePtr p = GetFirstElement("variables");
	if (p)
	{
		SetCurrent(p);
		p = GetChildrenNode();
		while (p)
		{
			std::string name = GetProperty("name");
			std::string type = GetProperty("type");
			std::string index = GetProperty("index");
			if (name.size())
			{
				VARIABLE *p = new VARIABLE(name, atoi(type.c_str()), atoi(index.c_str()));
				ref.push_back(p);
			}
			//
			p = GetNextNode();
		}
	}
}


