#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <map>
#include <string>
#include <Base64.h>
#include "RobotXMLFile.h"
#include "CodeTool.h"


void visa2(const unsigned char *p,size_t& addr)
{
	unsigned char c;
	c = p[addr++];
	printf(" %02x",c);
	c = p[addr++];
	printf(" %02x",c);
}


void visa4(const unsigned char *p,size_t& addr)
{
	unsigned char c;
	c = p[addr++];
	printf(" %02x",c);
	c = p[addr++];
	printf(" %02x",c);
	c = p[addr++];
	printf(" %02x",c);
	c = p[addr++];
	printf(" %02x",c);
}


int main(int argc,char *argv[])
{
	if (argc < 2)
	{
		printf("Usage: %s <.xml file>\n",*argv);
		exit(-1);
	}
	for (int i = 1; i < argc; i++)
	{
		RobotXMLFile x(argv[i]);

		if (x.IsOk())
		{
			CodeTool ct(x);
			std::string robot_name = x.GetString("name");
			std::string owner_uid = x.GetString("owner");

			printf("Disassembly of robot: %s\n",robot_name.c_str());
			printf("Created by: %s\n",owner_uid.c_str());

		if (ct.Sane())
		{
			unsigned char opcode;
			size_t addr = 0;
			while (addr < ct.GetCodesize())
			{
				printf("%04x %04x  ",addr/0x10000,addr%0x10000);
				opcode = ct.GetCode(addr++);
				int opsize = ct.GetOpsize(opcode);
				printf("%02x %s ",opcode,ct.GetOpcode(opcode).c_str());
				if (opsize == -1)
				{
				}
				else
				if (opsize == -2)
				{
					visa2(ct.GetBuf(),addr);
					unsigned char c;
					c = ct.GetBuf()[addr++]; // string length
					printf("  string length=%d  '",c);
					for (int i = 0; i < c; i++)
					{
						char c;
						c = ct.GetBuf()[addr++];
						printf("%c",c);
					}
				}
				else
				if (opsize == 2)
				{
					visa2(ct.GetBuf(), addr);
				}
				else
				if (opsize == 4)
				{
					visa4(ct.GetBuf(), addr);
				}
				if (opcode == 0x11 || opcode == 0x82)
				{
					printf("  body length = ");
					visa2(ct.GetBuf(), addr);
				}
				printf("\n");
			}
		}
		else
		{
			printf("Insane code\n");
		}

		} // if (x.IsOk())
	}
}


