#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <map>
#include <string>
#include <Base64.h>
#include <SocketHandler.h>
#include <StdoutLog.h>
#include "RobotXMLFile.h"
#include "InjectSocket.h"
#include "RowoHandler.h"
#include "CodeTool.h"


int main(int argc,char *argv[])
{
	if (argc < 2)
	{
		printf("Usage: %s <.xml file>\n",*argv);
		exit(-1);
	}
	RowoHandler h;
	StdoutLog log;
	h.RegStdLog(&log);
	for (int i = 1; i < argc; i++)
	{
		RobotXMLFile x(argv[i]);
		if (x.IsOk())
		{
			std::string robot_name = x.GetString("name");
			std::string owner_uid = x.GetString("owner");
//		std::string codestr64 = x.GetString("code");

			printf("Robot: %s\n",robot_name.c_str());
			printf("Created by: %s\n",owner_uid.c_str());
//			printf("Codestr64: %s\n",codestr64.c_str());
			// code sanity check
			CodeTool ct(x);
			if (ct.Sane())
			{
				// send file
				InjectSocket *p = new InjectSocket(h);
				p -> SetDeleteByHandler();
				p -> SetFilename(argv[i]);
				p -> Open("localhost",32766);
				h.Add(p);
				h.Select(1,0);
			}
			else
			{
				printf("Insane code\n");
			}
		}
	}
	while (h.GetCount())
	{
		h.Select(1,0);
	}
}


