#include <stdio.h>
#include <SocketHandler.h>
#include <StdoutLog.h>
#include <Uid.h> // from libSocketsEx
#include <ListenSocket.h>
#include "Robot.h"
#include "Map.h"
#include "Base.h"
#include "InjectSocket.h"
#include "RowoHandler.h"


std::string GetMyUid()
{
	std::string myuid;
	FILE *fil;
	if ((fil = fopen("myuid.txt","rt")) != NULL)
	{
		char slask[1000];
		fgets(slask,1000,fil);
		slask[strlen(slask) - 1] = 0;
		fclose(fil);
		myuid = slask;
	}
	else
	{
		Uid uid;
		myuid = uid.GetUid();
		fil = fopen("myuid.txt","wt");
		fprintf(fil,"%s\n",myuid.c_str());
		fclose(fil);
	}
	return myuid;
}


int main(int argc,char *argv[])
{
	RowoHandler h;
	StdoutLog log;
	h.RegStdLog(&log);
	ListenSocket<InjectSocket> ll(h);
	std::string myuid = GetMyUid();
	Map map;
	Base home(map);
	bool quit = false;
	struct timeval tvo;
	struct timezone tz;

	if (ll.Bind("localhost",32766) == -1)
	{
		exit(-1);
	}
	h.Add(&ll);

	// init handler, etc..
	h.SetMyUid(myuid);
	h.SetMap(&map);
	map.SetMax(1000, 1000);
	map.AddObject(&home, false);

	gettimeofday(&tvo,&tz);
	while (!quit)
	{
		h.Select(0,100000); // 10 ...
		struct timeval tv;
		gettimeofday(&tv,&tz);
		long diff = tv.tv_usec - tvo.tv_usec;
		if (diff < 0)
		{
			diff += 1000000;
		}
		if (tv.tv_sec != tvo.tv_sec)
		{
			if (map.objects_in_map() < 1000)
			{
				map.SpawnRandom();
			}
		}
		if (diff >= 50000) // ... 20 times/sec
		{
			map.IncreaseTime( diff );
			tvo = tv;
		}
	}
}


